/* Problem URL: https://codeforces.com/problemset/problem/2004/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, q;
    cin >> n >> q;

    int ac[256];
    ac['R'] = 1;
    ac['B'] = 2;
    ac['G'] = 4;
    ac['Y'] = 8;

    vi mask(n);

    vvi adj(16);

    rep(i, n) {
        string a;
        cin >> a;

        mask[i] = ac[a[0]] | ac[a[1]];
        adj[mask[i]].push_back(i);
    }

    rep(i, 16) {
        sortv(adj[i]);
    }

    while (q--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        if (mask[a] & mask[b]) {
            cout << abs(a - b) << '\n';
            continue;
        }

        int ans = oo;
        int f = min(a, b);

        rep(i, 16) {
            if (__builtin_popcount(i) != 2 || (i & mask[a]) == 0 || (i & mask[b]) == 0) {
                continue;
            }

            auto itr = upper_bound(all(adj[i]), f);
            if (itr != adj[i].end()) {
                rmin(ans, abs(*itr - a) + abs(*itr - b));
            }

            if (itr != adj[i].begin()) {
                itr--;
                rmin(ans, abs(*itr - a) + abs(*itr - b));
            }
        }

        cout << (ans == oo ? -1 : ans) << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
